import * as React from "react";
import { tween } from "./tween";
import { AnimateType, domAnimateProp, animateState } from "./animateType";
declare type Props = {
    animation: AnimateType | domAnimateProp;
    spanWrapEle?: boolean;
    styleObj?: React.CSSProperties;
    className?: string;
    display?: "block" | "inline-block" | "flex";
    duration?: number;
    runMount?: boolean;
};
declare type States = {};
declare class Animate extends React.PureComponent<Props, States> {
    static defaultProps: {
        duration: number;
        elementStr: string;
        className: string;
        display: string;
    };
    timer: number;
    boxDom: React.RefObject<HTMLDivElement>;
    state: States;
    easeType: keyof typeof tween;
    animateState: animateState;
    constructor(props: Props);
    valideAnimation(animation: Props["animation"]): void;
    componentDidMount(): void;
    registerEaseType(animation: Props["animation"]): this["easeType"];
    initAnimateStateToDom(animation: Props["animation"], dom: HTMLDivElement): void;
    getStart(animation: Props["animation"], dom: HTMLDivElement, runMount?: "start" | "end"): animateState;
    domExcute(dom: HTMLDivElement, animation: AnimateType, duration: number, runMout?: boolean): void;
    componentDidUpdate(preProps: Props): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export default Animate;
