import * as React from "react";
const DayComponent = ({ dayNum, disabled, showTimeObj, selTimeObj, curTime, clickSelHandle }) => {
    const year = showTimeObj.get("year"), month = showTimeObj.get("month");
    const selYear = selTimeObj.get("year"), selMon = selTimeObj.get("month"), selDay = selTimeObj.get("day");
    const isAble = !disabled ? " view-item " : "day-disabled";
    const isToday = (!disabled && year === curTime.year && month === curTime.month && curTime.day === dayNum) && "calendar-today" || "";
    const isSel = (!disabled && year === selYear && month === selMon && dayNum === selDay) && "calendar-sel" || "";
    return (React.createElement("li", { className: isAble + " " + isToday + " " + isSel, "data-sign": "day", "data-num": dayNum, onClick: (!isSel && clickSelHandle) || undefined },
        React.createElement("span", { className: "day-span" }, dayNum)));
};
export default class CalendarDayView extends React.PureComponent {
    getTimePickCom() {
        const { selTimeObj, changeTime, viewIndex } = this.props;
        const hour = selTimeObj.get("hour"), minute = selTimeObj.get("minute");
        return (React.createElement("div", { className: "m-time" },
            React.createElement("div", null,
                React.createElement("b", null, "\u65F6\u95F4\uFF1A\u00A0"),
                React.createElement("input", { type: "number", className: "wacth-time", "data-viewindex": viewIndex, max: "24", min: "0", value: hour, name: "hour", onChange: changeTime })),
            React.createElement("div", null,
                React.createElement("b", null, "\u00A0\u00A0:\u00A0"),
                React.createElement("input", { type: "number", className: "wacth-time", max: "59", "data-viewindex": viewIndex, min: "0", name: "minute", value: minute, onChange: changeTime }))));
    }
    getDayArr() {
        const { showTimeObj, curTime, selTimeObj, clickSelHandle } = this.props;
        const year = showTimeObj.get("year"), month = showTimeObj.get("month");
        const days = this.getMonDays(year, month);
        const monFirstDayToWeek = (new Date(year, month - 1, 1)).getDay();
        const dayArrleg = Math.ceil((days + monFirstDayToWeek) / 7);
        const daysArr = new Array(dayArrleg).fill("1").map((...args) => {
            const [, index] = args;
            switch (index) {
                case 0: {
                    const preMonDays = this.getMonDays(year, month - 1);
                    const preMonDayArr = Array.from({ length: monFirstDayToWeek }, (...args) => args[1] + 1).map(val => {
                        const day = preMonDays - monFirstDayToWeek + val;
                        return (React.createElement(DayComponent, { key: day, dayNum: day, disabled: true, curTime: curTime, selTimeObj: selTimeObj, showTimeObj: showTimeObj, clickSelHandle: undefined }));
                    });
                    const firstArr = Array.from({ length: 7 - monFirstDayToWeek }, (...args) => args[1] + 1).map(val => {
                        return (React.createElement(DayComponent, { dayNum: val, key: val, disabled: false, curTime: curTime, selTimeObj: selTimeObj, showTimeObj: showTimeObj, clickSelHandle: clickSelHandle }));
                    });
                    return (React.createElement("ul", { className: "data-group", key: index }, preMonDayArr.concat(firstArr)));
                }
                case dayArrleg - 1: {
                    const startDayNum = 7 * index - monFirstDayToWeek;
                    const count = (days + monFirstDayToWeek) % 7 || 7;
                    const lastArr = Array.from({ length: count }, (...args) => args[1] + 1).map(val => {
                        const day = val + startDayNum;
                        return (React.createElement(DayComponent, { dayNum: day, disabled: false, curTime: curTime, selTimeObj: selTimeObj, showTimeObj: showTimeObj, key: day, clickSelHandle: clickSelHandle }));
                    });
                    const lastMonDays = Array.from({ length: 7 - count }, (...args) => args[1] + 1).map((val) => {
                        return (React.createElement(DayComponent, { dayNum: val, disabled: true, curTime: curTime, selTimeObj: selTimeObj, showTimeObj: showTimeObj, key: val, clickSelHandle: undefined }));
                    });
                    return (React.createElement("ul", { className: "data-group", key: index }, lastArr.concat(lastMonDays)));
                }
                default: {
                    const startDayNum = 7 * index - monFirstDayToWeek;
                    const monDayArr = Array.from({ length: 7 }, (...args) => args[1] + 1).map((val) => {
                        const day = val + startDayNum;
                        return (React.createElement(DayComponent, { dayNum: day, key: day, disabled: false, curTime: curTime, selTimeObj: selTimeObj, showTimeObj: showTimeObj, clickSelHandle: clickSelHandle }));
                    });
                    return (React.createElement("ul", { className: "data-group", key: index }, monDayArr));
                }
            }
        });
        return daysArr;
    }
    getMonDays(year, mon) {
        const day = new Date(year, mon, 0);
        return day.getDate();
    }
    render() {
        const { time } = this.props;
        const timeCom = time ? this.getTimePickCom() : undefined;
        return (React.createElement("div", { className: "m-dayView item-calendar-view" },
            React.createElement("ul", { className: "week-group" },
                React.createElement("li", null, "\u65E5"),
                React.createElement("li", null, "\u4E00"),
                React.createElement("li", null, "\u4E8C"),
                React.createElement("li", null, "\u4E09"),
                React.createElement("li", null, "\u56DB"),
                React.createElement("li", null, "\u4E94"),
                React.createElement("li", null, "\u516D")),
            this.getDayArr(),
            timeCom));
    }
}
