import * as React from "react";
import { SlideBox } from "../animate/index";
import * as Immutable from "immutable";
import CalendarView from "./CalendarView";
import CalendarInp from "./CalendarInp";
import { timeStrValToTimeObjArr, calendarType, getInpTimeStrArr, getCurTime, getLastYear, timeStrToNumber, compareTimeRang } from "./objectFn";
import { event } from "../util/autoSlideUp";
class Calendar extends React.PureComponent {
    constructor(props) {
        super(props);
        this.eventId = `${new Date().getTime().toString()}-${this.props.field}`;
        this.curTime = getCurTime();
        this.fixProps = this.createFixProps();
        this.changeBasicState = (key, callback, obj) => {
            if (obj && key === "selTimeArr") {
                const { selTimeArr, rotate } = this.state;
                const { time, clickBefore, field, valFormatt } = this.props;
                return compareTimeRang(selTimeArr, obj.viewIndex, obj.showTimeObj, {
                    rotate: rotate,
                    time: time,
                    field,
                    valFormatt: valFormatt,
                    clickBefore,
                });
            }
            if (key === "rotate" && this.props.clickBefore) {
                const { selTimeArr } = this.state;
                const { time, clickBefore, field, valFormatt } = this.props;
                const val = callback(this.state);
                const calendarVal = getInpTimeStrArr(selTimeArr, val, time).join(" 至 ");
                const str = timeStrToNumber(calendarVal.split(" 至 "), valFormatt).join(",");
                if (clickBefore(str, {
                    field,
                    rotate: val,
                    valFormatt: valFormatt,
                }, selTimeArr)) {
                    return true;
                }
            }
            this.setState(pre => {
                const val = callback(pre);
                let obj = {};
                const { time } = this.props;
                if (key === "selTimeArr") {
                    const rotate = pre.rotate;
                    const calendarVal = getInpTimeStrArr(val, rotate, time).join(" 至 ");
                    obj = {
                        selTimeArr: val,
                        calendarVal,
                    };
                }
                else if (key === "rotate") {
                    const selTimeArr = pre.selTimeArr;
                    const calendarVal = getInpTimeStrArr(selTimeArr, val, time).join(" 至 ");
                    const showViewArr = this.getShowViewArr(val);
                    return {
                        calendarVal: calendarVal,
                        showViewArr: showViewArr,
                        rotate: val,
                    };
                }
                else {
                    obj = {
                        [key]: val,
                    };
                }
                return obj;
            }, () => {
                if (["rotate", "selTimeArr"].includes(key)) {
                    const { field, clickBack, valFormatt } = this.props;
                    const { rotate, calendarVal, selTimeArr } = this.state;
                    const val = timeStrToNumber(calendarVal.split(" 至 "), valFormatt).join(",");
                    clickBack(val, {
                        field,
                        rotate: rotate,
                        valFormatt: valFormatt
                    }, selTimeArr);
                }
            });
        };
        this.documentClickFn = () => {
            this.setState({
                expand: false,
            });
        };
        const { time, rotate, clickBack, clickBefore, field, ableClear, renderCallBack, valFormatt } = this.props;
        const selTimeArr = Immutable.fromJS(timeStrValToTimeObjArr(ableClear && !this.props.defaultTime, this.props, this.curTime));
        const timeVal = getInpTimeStrArr(selTimeArr, rotate, time);
        const showTimeArr = selTimeArr.getIn([0, "year"])
            ? selTimeArr
            : Immutable.fromJS(timeStrValToTimeObjArr(false, this.props, this.curTime));
        if (renderCallBack) {
            const val = timeStrToNumber(timeVal, valFormatt).join(",");
            const forbid = clickBefore ? clickBefore(val, {
                field,
                rotate: rotate,
                valFormatt: valFormatt
            }, selTimeArr) : false;
            if (!forbid) {
                clickBack(val, {
                    field,
                    rotate: rotate,
                    valFormatt: valFormatt
                }, selTimeArr);
            }
        }
        this.state = {
            expand: false,
            selTimeArr,
            showTimeArr,
            calendarVal: timeVal.join(" 至 "),
            rotate: rotate,
            pannelLastYear: showTimeArr.map((val) => {
                return getLastYear(val.get("year"));
            }),
            showViewArr: this.getShowViewArr(rotate),
            preInitTime: props.initTime,
            preRotate: props.rotate
        };
    }
    static getDerivedStateFromProps(nextProps, preState) {
        if (nextProps.initTime !== preState.preInitTime ||
            nextProps.rotate !== preState.preRotate) {
            const { time, rotate, clickBack, field, ableClear, renderCallBack, valFormatt, clickBefore, } = nextProps;
            const curTime = getCurTime();
            const objProps = nextProps.initTime ? Object.assign({}, nextProps, { defaultTime: nextProps.initTime.time }) : nextProps;
            const selTimeArr = Immutable.fromJS(timeStrValToTimeObjArr(ableClear, objProps, curTime));
            const timeVal = getInpTimeStrArr(selTimeArr, rotate, time);
            if (renderCallBack) {
                const str = timeStrToNumber(timeVal, valFormatt).join(",");
                const forbid = clickBefore ? clickBefore(str, {
                    field,
                    rotate: rotate,
                    valFormatt: valFormatt
                }, selTimeArr) : false;
                if (forbid) {
                    return {
                        preInitTime: nextProps.initTime,
                        preRotate: nextProps.rotate,
                    };
                }
                clickBack(str, {
                    field,
                    rotate: rotate,
                    valFormatt: valFormatt
                }, selTimeArr);
            }
            let animationArr = new Array(5).fill("fadeOut");
            animationArr[nextProps.rotate] = "fadeIn";
            const showTimeArr = selTimeArr.getIn([0, "year"])
                ? selTimeArr
                : Immutable.fromJS(timeStrValToTimeObjArr(false, objProps, curTime));
            return {
                expand: false,
                selTimeArr,
                showTimeArr,
                pannelLastYear: showTimeArr.map((val) => {
                    return val.get("year");
                }),
                calendarVal: timeVal.join(" 至 "),
                preInitTime: nextProps.initTime,
                rotate: nextProps.rotate,
                showViewArr: animationArr,
                preRotate: nextProps.rotate,
            };
        }
        else {
            return null;
        }
    }
    getShowViewArr(rotate) {
        let animationArr = new Array(5).fill("fadeOut");
        animationArr[rotate] = "fadeIn";
        return animationArr;
    }
    createFixProps() {
        const { style, time, noChangeRotate } = this.props;
        const obj = {
            style: style,
            time: time,
            noChangeRotate: noChangeRotate
        };
        return obj;
    }
    componentDidMount() {
        event.on(this.eventId, this.documentClickFn);
    }
    componentWillUnmount() {
        event.remove(this.eventId);
    }
    drop() {
        const { style, } = this.props;
        const { expand, selTimeArr, rotate, showViewArr, showTimeArr, pannelLastYear } = this.state;
        const secondViews = selTimeArr.size === 2 ? (React.createElement(CalendarView, { fixProps: this.fixProps, selTimeObj: selTimeArr.get(1), showTimeObj: showTimeArr.get(1), curTime: this.curTime, viewIndex: 1, lastYear: pannelLastYear.get(1), showViewArr: showViewArr, rotate: rotate, changeBasicState: this.changeBasicState })) : (undefined);
        const showViewIndex = showViewArr.indexOf("fadeIn");
        const boxW = style * ([235, 235, 228, 235, 292][showViewIndex]);
        return (React.createElement("div", { className: "g-calendar-box", style: { width: `${boxW}px`, } },
            React.createElement(SlideBox, { slide: expand },
                React.createElement("div", { style: { display: "flex", } },
                    React.createElement(CalendarView, { fixProps: this.fixProps, selTimeObj: selTimeArr.get(0), showViewArr: showViewArr, curTime: this.curTime, lastYear: pannelLastYear.get(0), showTimeObj: showTimeArr.get(0), rotate: rotate, viewIndex: 0, changeBasicState: this.changeBasicState }),
                    secondViews))));
    }
    renderCalendar() {
        const { noInp, width, placeholder, ableClear, style, require, disabled, field, matchTimeStr } = this.props;
        const { expand, calendarVal } = this.state;
        const inpCom = noInp ? undefined : (React.createElement(CalendarInp, { field: field, inpVal: calendarVal, placeholder: placeholder, disabled: disabled, require: require, matchTimeStr: matchTimeStr, eventId: this.eventId, ableClear: ableClear, curTime: this.curTime, changeBasicState: this.changeBasicState, style: style }));
        const activeName = expand ? "autoSlideUp" : "";
        return (React.createElement("div", { className: "g-calendar " + activeName, "data-event": this.eventId, style: { width: ~~width, } },
            inpCom,
            disabled ? undefined : this.drop()));
    }
    render() {
        const { children } = this.props;
        return children ? (React.createElement("div", { className: "m-flex-center" },
            React.createElement("span", { className: "lab-tit" }, children),
            this.renderCalendar())) : this.renderCalendar();
    }
}
Calendar.defaultProps = {
    rotate: calendarType.day,
    style: 1,
    defaultTime: "",
    width: 280,
    placeholder: "",
    valFormatt: "number",
};
export default Calendar;
