import * as React from "react";
import { ISelected, IDrop, drop, filedObj } from "./combo";
declare type props = {
    data: any[];
    idField?: string;
    textField?: string;
    noIcon?: boolean;
    noSearch?: boolean;
    disabled?: boolean;
    multiply?: boolean;
    tit?: string;
    field: string;
    itemIcon?: string;
    defaultVal?: string;
    width?: number;
    maxHeight?: number;
    dropWidth?: number;
    directionUp?: boolean;
    noRequire?: boolean;
    renderCallback?: boolean;
    ableClear?: boolean;
    initComboVal?: {
        id: string;
    };
    clickOrCheckForbid?: (node: IImmutalbeMap<any>, field: string, selectedArr: states['selected']) => boolean;
    formatterVal?: (selected: states["selected"]) => React.ReactChild;
    formatterDropItem?: (node: IImmutalbeMap<any>) => React.ReactChild;
    clickCallback(selected: ISelected[], field: string, node?: IImmutalbeMap<any>): void;
};
declare type states = {
    selected: IImmutalbeList<ISelected>;
    drop: boolean;
};
interface ICombo {
    eventId: string;
    dropStyle: {
        maxHeight: number;
    };
    selectFn(path?: string): void;
    dropToggle(e: React.MouseEvent): void;
    changeSelect(selected: states["selected"], node?: IImmutalbeMap<any>): void;
}
declare const wrapComboHC: <P extends "list" | "tree">(Drop: React.ComponentType<drop<P>>, comboType: "list" | "tree") => {
    new (props: props & IDrop[P]): {
        eventId: string;
        filedObj: IImmutalbeMap<filedObj<P>>;
        dropStyle: ICombo["dropStyle"];
        selectFn: ICombo["selectFn"];
        bindSelectFn: (fn: any) => void;
        initFieldObj(props: props & IDrop[P]): void;
        dropToggle: (e: React.MouseEvent) => void;
        initState(): states;
        documentClickFn: () => void;
        componentDidMount(): void;
        componentWillUnmount(): void;
        initSelect: (selected: states["selected"]) => void;
        changeSelect: (selected: states["selected"], node?: IImmutalbeMap<any> | undefined) => void;
        renderCombox(): JSX.Element;
        render(): JSX.Element;
        context: any;
        setState<K extends "drop" | "selected">(state: states | ((prevState: Readonly<states>, props: Readonly<props & IDrop[P]>) => states | Pick<states, K> | null) | Pick<states, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
        readonly props: Readonly<props & IDrop[P]> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<states>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<props & IDrop[P]>, nextState: Readonly<states>, nextContext: any): boolean;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<props & IDrop[P]>, prevState: Readonly<states>): any;
        componentDidUpdate?(prevProps: Readonly<props & IDrop[P]>, prevState: Readonly<states>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<props & IDrop[P]>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<props & IDrop[P]>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<props & IDrop[P]>, nextState: Readonly<states>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<props & IDrop[P]>, nextState: Readonly<states>, nextContext: any): void;
    };
    defaultProps: {
        idField: string;
        textField: string;
        childField: string;
        width: number;
        maxHeight: number;
        defaultVal: string;
        clickOrCheckForbid: () => boolean;
    };
    contextType?: React.Context<any> | undefined;
};
export default wrapComboHC;
