import * as React from "react";
import wrapComboHQC from "./ComboBasic";
import * as Immutable from "immutable";
import { DropItem, activeStatus } from "./DropItem";
import { Search } from "../input/index";
const formatterData = function (props, defaultVal) {
    const { filedObj, data, initSelect } = props;
    const id = filedObj.get("idField");
    const text = filedObj.get("textField");
    const multiply = filedObj.get("multiply");
    const defaultValArr = defaultVal.split(",");
    if (!multiply && defaultValArr.length > 1) {
        defaultValArr.length = 1;
    }
    const copyData = JSON.parse(JSON.stringify(data));
    let listSelect = [];
    let oldSelected = "";
    const _data = copyData.map((val, index) => {
        const isDefault = defaultValArr.includes(`${val[id]}`);
        val.active = isDefault ? activeStatus.select : activeStatus.noSelect;
        if (isDefault) {
            listSelect.push({ id: val[id], text: val[text] });
            if (!multiply) {
                oldSelected = `${index}`;
            }
        }
        return val;
    });
    if (initSelect) {
        initSelect(Immutable.List(listSelect));
    }
    return {
        data: Immutable.fromJS(_data),
        singleClickPre: oldSelected,
    };
};
const clickFn = function (index, props, state) {
    const { filedObj, selected, changeSelect } = props;
    const multipy = filedObj.get("multiply");
    const idField = filedObj.get("idField");
    const textField = filedObj.get("textField");
    const clickForbid = filedObj.get("clickOrCheckForbid");
    const comField = filedObj.get("field");
    let oldSelectedIndex = state.singleClickPre;
    const data = state.immutableData;
    let _data = data;
    let _select = selected;
    let newNode = _data.getIn([index]);
    if (!newNode) {
        return undefined;
    }
    if (clickForbid(newNode, comField)) {
        return undefined;
    }
    if (!multipy) {
        if (oldSelectedIndex === index) {
            return undefined;
        }
        if (oldSelectedIndex) {
            _data = _data.updateIn([oldSelectedIndex], (val) => {
                return val && val.set("active", activeStatus.noSelect);
            });
        }
        _select = _select.clear();
    }
    _data = _data.updateIn([index], (val) => {
        const active = val.get("active") === activeStatus.select
            ? activeStatus.noSelect
            : activeStatus.select;
        if (active === activeStatus.select) {
            _select = _select.push({
                id: val.get(idField),
                text: val.get(textField),
            });
        }
        else {
            if (multipy) {
                _select = _select.filter((_val) => {
                    return _val.id !== val.get(idField);
                });
            }
        }
        const node = val.set("active", active);
        newNode = node;
        return node;
    });
    changeSelect(_select, newNode);
    if (!multipy) {
        oldSelectedIndex = index;
    }
    return {
        data: _data,
        singleClickPre: oldSelectedIndex,
    };
};
class DropList extends React.PureComponent {
    constructor(props) {
        super(props);
        this.state = this.initState(this.props);
        this.asyncDefaultVal = !!this.props.data.length;
        this.clikItem = (id) => {
            if (!id) {
                this.clear();
                return;
            }
            const { immutableData } = this.state;
            const { filedObj } = this.props;
            const idField = filedObj.get("idField");
            const index = immutableData.findIndex((val) => `${val.get(idField)}` === `${id}`);
            if (index !== -1) {
                this.clickFnForListMethod(`${index}`);
            }
        };
        this.clickFnForListMethod = (index) => {
            this.setState((pre) => {
                const obj = clickFn(index, this.props, pre);
                if (obj) {
                    return {
                        immutableData: obj.data,
                        singleClickPre: obj.singleClickPre,
                    };
                }
                else {
                    return null;
                }
            });
        };
        this.closeFn = () => {
            const { data, selected, filedObj } = this.props;
            const defaultVal = selected.map((val) => val.id).join(",");
            const { data: immutableData, singleClickPre } = formatterData({ filedObj, data }, defaultVal);
            this.setState({
                immutableData,
                singleClickPre,
            });
        };
        this.searchFn = (key) => {
            const { filedObj, data, selected } = this.props;
            const textField = filedObj.get("textField");
            let searchResult = data.filter((val) => val[textField].includes(key));
            const defaultVal = selected.map((val) => val.id).join(",");
            const { data: immutableData, singleClickPre } = formatterData({
                data: searchResult,
                filedObj,
            }, defaultVal);
            this.setState({
                immutableData,
                singleClickPre,
            });
        };
        this.state = this.initState(props);
        const { clickMethod } = props;
        clickMethod(this.clikItem);
    }
    static getDerivedStateFromProps(nextProps, preState) {
        const { preData, preInitComboVal, asyncDefaultVal } = preState;
        if (nextProps.data !== preData) {
            let defaultVal = "";
            if (nextProps.initComboVal !== preInitComboVal) {
                defaultVal = nextProps.initComboVal ? nextProps.initComboVal.id : "";
            }
            else {
                if (asyncDefaultVal) {
                    defaultVal = nextProps.filedObj.get("defaultVal");
                }
                else {
                    defaultVal = nextProps.selected.map((val) => val.id).join(",");
                }
            }
            const { filedObj, initSelect, data } = nextProps;
            const resObj = formatterData({ filedObj, data, initSelect }, defaultVal);
            return {
                preData: nextProps.data,
                immutableData: resObj.data,
                asyncDefaultVal: false,
                singleClickPre: resObj.singleClickPre,
            };
        }
        else if (nextProps.initComboVal !== preInitComboVal) {
            const defaultVal = nextProps.initComboVal
                ? nextProps.initComboVal.id
                : "";
            const { filedObj, initSelect, data } = nextProps;
            const resObj = formatterData({ filedObj, data, initSelect }, defaultVal);
            return {
                preInitComboVal: nextProps.initComboVal,
                immutableData: resObj.data,
                singleClickPre: resObj.singleClickPre,
            };
        }
        return null;
    }
    initState(props) {
        const { filedObj, data, initComboVal, initSelect } = props;
        const defaultVal = filedObj.get("defaultVal");
        const obj = formatterData({
            filedObj,
            data,
            initSelect,
        }, defaultVal);
        return {
            immutableData: obj.data,
            preData: data,
            preInitComboVal: initComboVal,
            singleClickPre: obj.singleClickPre,
            asyncDefaultVal: data.length === 0,
        };
    }
    clear() {
        const { changeSelect, selected, filedObj } = this.props;
        let _selected = selected;
        const idField = filedObj.get("idField");
        this.setState((pre) => {
            let _data = pre.immutableData;
            _data = _data.withMutations((list) => {
                return list.map((val) => {
                    const has = _selected.find((select) => `${select.id}` === `${val.get(idField)}`);
                    if (has) {
                        return val.set("active", activeStatus.noSelect);
                    }
                    else {
                        return val;
                    }
                });
            });
            return {
                immutableData: _data,
                singleClickPre: "",
            };
        });
        changeSelect(Immutable.List([]));
    }
    main() {
        const { immutableData } = this.state;
        const { filedObj, dropStyle, formatterDropItem } = this.props;
        const idField = filedObj.get("idField");
        const noSearch = filedObj.get("noSearch");
        const com = immutableData.map((node, index) => {
            return (React.createElement(DropItem, { key: node.get(idField), clickFn: this.clickFnForListMethod, node: node, formatterDropItem: formatterDropItem, fieldObj: filedObj, index: `${index}` }));
        });
        const searchCom = !noSearch ? (React.createElement("div", { style: { paddingBottom: "0.5em", } },
            React.createElement(Search, { field: "search", searchHandle: this.searchFn, closeHandle: this.closeFn }))) : undefined;
        return (React.createElement("div", { className: "drop-main" },
            searchCom,
            React.createElement("ul", { style: dropStyle, className: "drop-ul" }, com)));
    }
    render() {
        return this.props.disabled ? null : this.main();
    }
}
export default wrapComboHQC(DropList, "list");
