import * as React from "react";
declare type props = {
    msg?: string;
    type?: "crash" | "noFind";
    init: {
        init: boolean;
    };
    bindGetHasError?: (getHasErrorFn: () => boolean) => void;
};
declare type states = {
    hasError: boolean;
    preInit: {
        init: boolean;
    };
};
export default class ErrorBoundary extends React.Component<props, states> {
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    static getDerivedStateFromError(_error: any): {
        hasError: boolean;
    };
    state: states;
    constructor(props: props);
    getHasError: () => boolean;
    reload: () => void;
    componentDidCatch(_error: any, _info: any): void;
    render(): {} | null | undefined;
}
export {};
