import * as React from "react";
import { SvgIcon } from "../my-icon/index";
class CheckBox extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {};
        this.clickFn = (e) => {
            e.stopPropagation();
        };
    }
    getClassName(disabled) {
        let name = "";
        const { type, checked, hasChecked } = this.props;
        if (type === "checkbox") {
            name = checked ? "checkbox-marked" : hasChecked ? "checkbox-has-selected" : "checkbox-blank";
        }
        else {
            name = checked ? "radio-on" : "radio-off";
        }
        return disabled ? `dis-${name}` : name;
    }
    render() {
        const { type, name, value, checked, changeHandle, children, disabled } = this.props;
        const className = this.getClassName(disabled);
        const disabledName = disabled ? "disabled-box" : "";
        return (React.createElement("label", { className: `m-label m-lab-${type} ${disabledName}`, onClick: this.clickFn },
            React.createElement("span", { className: `wrap-icon ${className}` },
                React.createElement(SvgIcon, { className: className }),
                React.createElement("input", { type: type, className: "checkBox-inp", name: name, checked: checked, value: value, onChange: changeHandle, disabled: disabled })),
            children));
    }
}
CheckBox.defaultProps = {
    type: "radio",
};
export default CheckBox;
