import * as React from "react";
declare type props = {
    searchHandle: (keyword: string, field: string) => void;
    closeHandle?: (field: string) => void;
    tip?: string;
    width?: number;
    defaultVal?: string;
    field: string;
};
declare type states = {
    searching: boolean;
    keyword: string;
    preField: string;
};
interface ISearch {
    closeSearch(): void;
}
declare class Search extends React.PureComponent<props, states> implements ISearch {
    static defaultProps: {
        tip: string;
    };
    static getDerivedStateFromProps(nextProps: props, preState: states): Partial<states> | null;
    state: states;
    toggleSearch: () => void;
    closeSearch: () => void;
    keyPress: (e: React.KeyboardEvent) => void;
    changeFn: (e: React.ChangeEvent<HTMLInputElement>) => void;
    render(): JSX.Element;
}
export default Search;
