import * as React from "react";
declare type ModalProps = {
    noshade?: boolean;
    wrap?: HTMLElement;
    tit: string;
    className?: string;
    field: string;
    toggleFn: (field: string, show: boolean) => void;
    width?: number;
    show: boolean;
    customFootFn?: () => JSX.Element;
    sureFn?: (field: string) => void;
};
declare type ModalState = {
    pointX: number;
    pointY: number;
    preShow: boolean;
    init: boolean;
};
interface IModal {
    wrap: HTMLElement;
    modalDom: React.RefObject<HTMLDivElement>;
    headMouseDown(e: React.MouseEvent): void;
}
export default class Modal extends React.PureComponent<ModalProps, ModalState> implements IModal {
    static getDerivedStateFromProps(nextProps: ModalProps, preState: ModalState): {
        init: boolean;
    } | null;
    wrap: HTMLElement;
    modalDom: React.RefObject<HTMLDivElement>;
    state: {
        pointX: number;
        pointY: number;
        preShow: boolean;
        init: boolean;
    };
    constructor(props: ModalProps);
    headMouseDown: (e: React.MouseEvent) => void;
    close: () => void;
    sureFn: () => void;
    headMouseUp: () => void;
    getModalFoot(): JSX.Element | undefined;
    getModal(): React.ReactPortal;
    render(): JSX.Element;
}
export {};
