import * as React from "react";
import { IScrollMethods } from "./scroll";
declare type Props = {
    height?: number;
    time?: number;
    bindIntiScroll?: (scrollMethods: IScrollMethods) => void;
    className?: string;
    keepBarShow?: boolean;
    noStopPageScroll?: boolean;
};
declare type States = {
    showBar: boolean;
    moveBarH: number;
    preH?: number;
};
interface IScrollBox {
    locateBar(e: React.MouseEvent<HTMLDivElement>): void;
}
declare class ScrollBox extends React.PureComponent<Props, States> implements IScrollBox {
    static defaultProps: {
        className: string;
    };
    moveBar: React.RefObject<HTMLDivElement>;
    state: States;
    scrollBoxH: number;
    scrollMainH: number;
    scrollMethods: IScrollMethods;
    timer: number;
    upTimer: number;
    constructor(props: Props);
    scrollToTop: (top: number) => void;
    barMove: (e: MouseEvent) => void;
    barMoveEven: (e: MouseEvent) => void;
    componentDidMount(): void;
    componentWillUnmount(): void;
    upDateInit: (defaultH?: number | undefined) => void;
    animateScroll(start: number, end: number, callback: () => void): void;
    componentDidUpdate(prevProps: Props, prevState: States): void;
    barClick: (e: React.MouseEvent<HTMLDivElement>) => void;
    cancelBarMove: () => void;
    mouseOver: (e: React.MouseEvent<HTMLDivElement>) => void;
    mouseLeave: () => void;
    mainMousewheel: (e: React.WheelEvent) => void;
    locateBar: (e: React.MouseEvent<HTMLDivElement>) => void;
    stopProp<k extends Event>(e: k): void;
    stopWhell<k extends Event>(e: k): void;
    render(): JSX.Element;
}
export default ScrollBox;
