import * as React from "react";
import { ScrollBox } from "../scroll/index";
import { IColumnItem, ITableStates, fieldObj } from "./mytable";
declare type Props = {
    data: any[];
    children: (React.ReactElement<IColumnItem> | undefined)[];
    hasBorder?: boolean;
    height?: number;
    noPageNums?: boolean;
    idField: string;
    checkbox?: boolean;
    defaultSel?: string;
    tabField?: string;
    emptyTxt?: string;
    initSelectVal?: {
        id: string;
    };
    bindGetSelectedFn?: (getSelected: () => IImmutalbeList<IImmutalbeMap<any>>) => void;
};
declare type States = ITableStates;
interface ITable {
    fieldObj: fieldObj;
}
declare enum checkAllStataus {
    hasChecked = "hasCheck",
    checked = "checked",
    noChecked = "noChecked"
}
declare class Table extends React.PureComponent<Props, States> implements ITable {
    static defaultProps: {
        defaultSel: string;
        emptyTxt: string;
    };
    static colItem: React.FunctionComponent<IColumnItem>;
    static getDerivedStateFromProps(nextProps: Props, preState: States): null | Partial<States>;
    fieldObj: {
        idField: string;
        checkbox: boolean | undefined;
        column: IColumnItem[];
        tabField: string | undefined;
        noPageNums: boolean | undefined;
    };
    tableContainer: React.RefObject<HTMLDivElement>;
    scrollRef: React.RefObject<ScrollBox>;
    constructor(props: Props);
    getSelected: () => IImmutalbeList<IImmutalbeMap<any>>;
    componentDidMount(): void;
    getSnapshotBeforeUpdate(preProps: Props, _preState: States): true | null;
    componentDidUpdate(_preProps: Props, _preState: States, snapshot: any): void;
    initFixObj(): {
        idField: string;
        checkbox: boolean | undefined;
        column: IColumnItem[];
        tabField: string | undefined;
        noPageNums: boolean | undefined;
    };
    scrollToSeletItem(): void;
    getColGroupCom(): JSX.Element;
    checkCurPageAll: (e: React.ChangeEvent<HTMLInputElement>) => void;
    getCurPageData(): IImmutalbeList<IImmutalbeMap<any>>;
    countCurPageTotalStatus(): checkAllStataus;
    getFixHead(): JSX.Element;
    changeState: <P extends "preData" | "perNums" | "curPage" | "tableData" | "preInitSelectVal" | "curOptId">(field: P, data: ITableStates[P]) => void;
    getTableBody(): JSX.Element;
    selectedHandle: (e: React.MouseEvent<HTMLTableCellElement>) => void;
    render(): JSX.Element;
}
export default Table;
