export interface IColumnItem {
    field: string;
    children: string;
    align?: "center" | "left" | 'right';
    width: number;
    formatter?: (node: IImmutalbeMap<any>, index: number, tabField?: string) => React.ReactChild;
}
declare type group = React.ComponentElement<IColumnItem, any>;
export interface ICommon {
    node: {
        [key: string]: any;
        active: 'selected' | 'hasSelect' | 'noSelect';
        expand: boolean;
    };
    data: IImmutalbeList<IImmutalbeMap<ICommon['node']>>;
    col: (Omit<IColumnItem, 'children'> & {
        text: string;
    });
    groupCol: {
        children: group[] | group;
        forzen?: boolean;
    };
    config: Omit<ICommon['groupCol'], 'children'> & {
        child: ICommon['col'][];
        width: number;
    };
    fixObj: {
        childField: string;
        noOrder?: boolean;
        multiply?: boolean;
        itemIcon?: string;
        idField: string;
        defaultSel?: string;
        tabField?: string;
        emptyTxt?: string;
    };
    changeState(path: string, key: 'expand' | 'active' | 'checkPar'): void;
}
export declare type fieldObj = {
    column: IColumnItem[];
    idField: string;
    noOrder?: boolean;
    checkbox?: boolean;
    tabField?: string;
};
export {};
