import { closertPar } from "./domUtil";
const eventData = {};
const event = {
    on: function (k, fn) {
        eventData[k] = fn;
    },
    emit: function (k, argObj) {
        const fn = eventData[k];
        if (!fn) {
            return;
        }
        eventData[k](argObj);
    },
    remove: function (k) {
        if (eventData[k]) {
            delete eventData[k];
        }
    }
};
const slideOther = (_e, excludekey) => {
    const activeCom = document.querySelector(".autoSlideUp");
    if (!activeCom) {
        return;
    }
    const k = activeCom.dataset.event;
    if (excludekey && excludekey === k) {
        return;
    }
    event.emit(k, activeCom);
};
document.addEventListener("click", function (e) {
    const target = e.target;
    const par = closertPar(target, "autoSlideUp");
    if (par) {
        return;
    }
    slideOther(e);
});
export { slideOther, event };
