import * as React from "react";
import LoadCom from "../loading/Loading";
class RouterLoad extends React.PureComponent {
    constructor() {
        super(...arguments);
        this.state = {
            Com: undefined,
            preLoadObj: this.props.loadObj
        };
    }
    componentDidMount() {
        const { loadObj } = this.props;
        loadObj.loader().then((com) => {
            this.setState({
                Com: com.default,
            });
        });
    }
    getLoad() {
        const { loadObj: { loading } } = this.props;
        return loading ? loading() : React.createElement(LoadCom.LoadingCom, null);
    }
    componentDidUpdate() {
        const { loadObj } = this.props;
        if (this.state.preLoadObj !== loadObj) {
            loadObj.loader().then((com) => {
                this.setState({
                    Com: com.default,
                    preLoadObj: loadObj,
                });
            });
        }
    }
    render() {
        const { Com } = this.state;
        const { children } = this.props;
        return !Com ? this.getLoad() : children(Com);
    }
}
const loadable = function (loadObj) {
    return (route) => {
        return (React.createElement(RouterLoad, { loadObj: loadObj }, (Com) => React.createElement(Com, Object.assign({}, route))));
    };
};
export default loadable;
